## dwz 0.12

=== Makefile ===
CFLAGS = -O2 -g
DWZ_VERSION := $(shell cat VERSION)
override CFLAGS += -Wall -W -D_FILE_OFFSET_BITS=64 -DDWZ_VERSION='"$(DWZ_VERSION)"'
prefix = /usr
exec_prefix = $(prefix)
bindir = $(exec_prefix)/bin
datarootdir = $(prefix)/share
mandir = $(datarootdir)/man
OBJECTS = dwz.o hashtab.o sha1.o dwarfnames.o
dwz: $(OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $^ -lelf
install: dwz
	install -D dwz $(DESTDIR)$(bindir)/dwz
	install -D -m 644 dwz.1 $(DESTDIR)$(mandir)/man1/dwz.1
clean:
	rm -f $(OBJECTS) *~ core* dwz

## dwz 0.4

=== debian/changelog ===
dwz (0.4-1) unstable; urgency=low

  * Initial release.

 -- Matthias Klose <doko@debian.org>  Mon, 25 Jun 2012 11:44:53 +0200

=== debian/control ===
Source: dwz
Section: devel
Priority: extra
Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
Uploaders: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 8.0.0), libelf-dev
Standards-Version: 3.9.3
Homepage: http://sourceware.org/git/?p=dwz.git;a=summary

Package: dwz
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: DWARF compression tool
 DWARF optimizer and duplication removal utility.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CFLAGS  := $(shell dpkg-buildflags --get CFLAGS)
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@ 

override_dh_auto_build:
	dh_auto_build -- CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"

## dwz 0.8

=== debian/changelog ===
dwz (0.8-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sun, 27 Jan 2013 21:44:18 +0100

## dwz 0.10

=== debian/changelog ===
dwz (0.10-1) unstable; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sat, 11 May 2013 16:40:55 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 8.0.0), libelf-dev
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://sourceware.org/git/?p=dwz.git;a=summary
 
 Package: dwz

## dwz 0.11

=== debian/changelog ===
dwz (0.11-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Thu, 27 Mar 2014 11:01:56 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 8.0.0), libelf-dev
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://sourceware.org/git/?p=dwz.git;a=summary
 
 Package: dwz

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-CFLAGS  := $(shell dpkg-buildflags --get CFLAGS)
+CFLAGS  := $(shell dpkg-buildflags --get CPPFLAGS; dpkg-buildflags --get CFLAGS)
 LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
 
 %:

## dwz 0.12

=== debian/changelog ===
dwz (0.12-2) unstable; urgency=medium

  * Make the package M-A: foreign.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Wed, 25 Oct 2017 09:33:11 +0200

dwz (0.12-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Mon, 15 Feb 2016 20:06:32 +0100

=== debian/control ===
Source: dwz
Section: devel
Priority: optional
Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
Uploaders: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 9), libelf-dev
Standards-Version: 4.1.1
Homepage: http://sourceware.org/git/?p=dwz.git;a=summary

Package: dwz
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: DWARF compression tool
 DWARF optimizer and duplication removal utility.

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
 
 %:
-	dh $@ 
+	dh $@ --parallel
 
 override_dh_auto_build:
 	dh_auto_build -- CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"

## dwz 0.12.20190723

=== debian/changelog ===
dwz (0.12.20190723-1) unstable; urgency=medium

  * New upstream snapshot.
    - PR 24823, MIPS: Require single pointer size.
    - Mark DW_OP_GNU_variable_value-referenced DIEs with die_no_multifile.

 -- Matthias Klose <doko@debian.org>  Tue, 23 Jul 2019 15:32:17 +0200

dwz (0.12.20190716-1) unstable; urgency=medium

  * New upstream snapshot.
    - Don't expect smaller executable when using objcopy and eu-unstrip.
    - Require compatible objcopy and eu-unstrip for objcopy-eu-unstrip*.sh.
      Closes: #932019.

 -- Matthias Klose <doko@debian.org>  Tue, 16 Jul 2019 15:59:50 +0200

dwz (0.12.20190711-1) unstable; urgency=medium

  * New upstream snapshot.
    - If .debug_info section not present, exit with 0.

 -- Matthias Klose <doko@debian.org>  Fri, 12 Jul 2019 00:25:25 +0200

dwz (0.12.20190710-1) unstable; urgency=medium

  * New upstream snapshot.
    - Fix PR dwz/24783, verify_sections assert on MIPS.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Wed, 10 Jul 2019 09:29:56 +0200

dwz (0.12.20190706-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Matthias Klose <doko@debian.org>  Sat, 06 Jul 2019 13:58:15 +0200

dwz (0.12.20190703-1) experimental; urgency=medium

  * New upstream snapshot.
  * Remove patches applied upstream.

 -- Matthias Klose <doko@debian.org>  Wed, 03 Jul 2019 09:28:13 +0200

dwz (0.12.20190702-2) experimental; urgency=medium

  * New upstream snapshot.
  * Fix manpage installation.
  * Bump standards version.
  * Add more test dependencies.

 -- Matthias Klose <doko@debian.org>  Tue, 02 Jul 2019 10:19:05 +0200

dwz (0.12-3) unstable; urgency=medium

  * Add DW_OP_GNU_variable_value support (taken from the trunk).
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Tue, 11 Dec 2018 12:06:52 +0100

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,13 @@
 Priority: optional
 Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
-Build-Depends: debhelper (>= 9), libelf-dev
-Standards-Version: 4.1.1
-Homepage: http://sourceware.org/git/?p=dwz.git;a=summary
+Build-Depends: debhelper (>= 9),
+  libelf-dev,
+  dejagnu <!nocheck>,
+  elfutils <!nocheck>,
+  gdb <!nocheck>,
+Standards-Version: 4.4.0
+Homepage: https://www.sourceware.org/dwz/
 
 Package: dwz
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,12 @@
 LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
 
 %:
-	dh $@ --parallel
+	dh $@ --parallel --buildsystem=makefile --builddirectory=build
+
+override_dh_auto_configure:
+	rm -rf build
+	mkdir build
+	cd build && ../configure
 
 override_dh_auto_build:
 	dh_auto_build -- CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"

## dwz 0.13

=== debian/changelog ===
dwz (0.13-5) unstable; urgency=medium

  * Apply updates from the trunk.
    - Fix PR25252.

 -- Matthias Klose <doko@debian.org>  Fri, 06 Dec 2019 20:04:31 +0100

dwz (0.13-4) unstable; urgency=medium

  * Apply updates from the trunk.
    - Fix PR24169.

 -- Matthias Klose <doko@debian.org>  Thu, 28 Nov 2019 11:25:00 +0100

dwz (0.13-3) unstable; urgency=medium

  * Apply updates from the trunk.
    - Fix PR24764, PR25024. Closes: #892828.

 -- Matthias Klose <doko@debian.org>  Wed, 27 Nov 2019 21:25:08 +0100

dwz (0.13-2) unstable; urgency=medium

  * Apply updates from the trunk.
    - Fix PR 2509, taken from the trunk. Closes: #942193.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Thu, 07 Nov 2019 14:01:46 +0100

dwz (0.13-1build1) eoan; urgency=medium

  * Test build.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 07 Sep 2019 12:40:19 +0200

dwz (0.13-1) unstable; urgency=medium

  * dwz 0.13 release.

 -- Matthias Klose <doko@debian.org>  Sun, 11 Aug 2019 17:20:00 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
   dejagnu <!nocheck>,
   elfutils <!nocheck>,
   gdb <!nocheck>,
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Homepage: https://www.sourceware.org/dwz/
 
 Package: dwz

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,9 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
+DEB_BUILD_OPTIONS := $(DEB_BUILD_OPTIONS) nostrip noopt
+export DEB_BUILD_OPTIONS
 
 CFLAGS  := $(shell dpkg-buildflags --get CPPFLAGS; dpkg-buildflags --get CFLAGS)
 LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
@@ -17,3 +20,6 @@
 
 override_dh_auto_build:
 	dh_auto_build -- CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"
+
+override_dh_auto_test:
+	-dh_auto_test

## dwz 0.13%2B20210201

=== debian/changelog ===
dwz (0.13+20210201-1) unstable; urgency=medium

  * Snapshot build, taken from the trunk 20210201.
    - Fix aborting "write_types: Assertion `ref && ref->die_dup == NULL'".
    - [testsuite] Fix make check CC="gcc -m32".

 -- Matthias Klose <doko@debian.org>  Sat, 06 Feb 2021 11:29:45 +0100

dwz (0.13+20210126-1) unstable; urgency=medium

  * Snapshot build, taken from the trunk 20210118.
    - PR dwz/27212, PR dwz/27213, assorted DW_FORM_implicit_const fixes.
    - Don't crash on DWARF5 .debug_line table with zero files.
    - Add DIE offsets in error messages to make it easier to find what
      is wrong.

 -- Matthias Klose <doko@debian.org>  Fri, 29 Jan 2021 17:17:39 +0100

dwz (0.13+20210118-1) unstable; urgency=medium

  * Snapshot build, taken from the trunk 20210118.
    - Fix reading and adjusting of DWARF5 .debug_loclists.

 -- Matthias Klose <doko@debian.org>  Tue, 19 Jan 2021 08:55:43 +0100

dwz (0.13+20201015-2) unstable; urgency=medium

  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Sun, 06 Dec 2020 12:56:44 +0100

dwz (0.13+20201015-1) experimental; urgency=medium

  * Snapshot build, taken from the trunk 20201015.

 -- Matthias Klose <doko@debian.org>  Thu, 15 Oct 2020 16:29:25 +0200

dwz (0.13+20200219-1) experimental; urgency=medium

  * Snapshot build, taken from the trunk 20200219.
  * Bump debhelper and standards versions.

 -- Matthias Klose <doko@debian.org>  Tue, 21 Jul 2020 13:17:01 +0200

## dwz 0.13+20210118

=== Makefile ===
ifneq ($(srcdir),)
VPATH = $(srcdir)
else
srcdir=$(shell pwd)
endif
CFLAGS = -O2 -g
DWZ_VERSION := $(shell cat $(srcdir)/VERSION)
override CFLAGS += -Wall -W -D_FILE_OFFSET_BITS=64 \
	-DDWZ_VERSION='"$(DWZ_VERSION)"' $(shell cat $(srcdir)/COPYRIGHT_YEARS)
prefix = /usr
exec_prefix = $(prefix)
bindir = $(exec_prefix)/bin
datarootdir = $(prefix)/share
mandir = $(datarootdir)/man
OBJECTS = dwz.o hashtab.o sha1.o dwarfnames.o
dwz: $(OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $^ -lelf
install: dwz
	install -D dwz $(DESTDIR)$(bindir)/dwz
	install -D -m 644 $(srcdir)/dwz.1 $(DESTDIR)$(mandir)/man1/dwz.1
clean:
	rm -f $(OBJECTS) *~ core* dwz $(TEST_EXECS) $(DWZ_TEST_SOURCES) \
	  dwz.log dwz.sum
	rm -Rf testsuite-bin tmp.*

PWD:=$(shell pwd -P)

TEST_SRC = $(srcdir)/testsuite/dwz.tests
TEST_EXECS_DWARF_ASM = no-multifile-prop invalid-dw-at-stmt-list-encoding
TEST_EXECS_x86_64 = py-section-script dw2-skip-prologue \
	implptr-64bit-d2o4a8r8t0 varval
TEST_EXECS = hello dwz-for-test min two-typedef start hello-gold-gdb-index \
	start-gold hello-gnu-pubnames $(TEST_EXECS_DWARF_ASM) \
	$(TEST_EXECS_$(UNAME)) odr-struct odr-class odr-union odr-struct-ns \
	odr-class-ns odr-union-ns odr-loc def-decl

UNAME:=$(shell uname -p)

hello:
	$(CC) $(TEST_SRC)/hello.c -o $@ -g

hello-gnu-pubnames:
	$(CC) $(TEST_SRC)/hello.c -o $@ -g -ggnu-pubnames || touch $@

dw2-skip-prologue:
	$(CC) $(TEST_SRC)/dw2-skip-prologue.S $(TEST_SRC)/dw2-skip-prologue.c \
	  -DINLINED -DPTRBITS=64 -o $@

py-section-script:
	$(CC) $(TEST_SRC)/py-section-script.s -o $@ -g

DWZ_TEST_SOURCES := $(patsubst %.o,%-for-test.c,$(OBJECTS))

%-for-test.c: %.c
	sed 's/__GNUC__/NOT_DEFINED/' $< > $@

dwz-for-test: $(DWZ_TEST_SOURCES)
	$(CC) $(DWZ_TEST_SOURCES) -O2 -g -lelf -o $@ -Wall -W -DDEVEL \
	  -D_FILE_OFFSET_BITS=64 -DDWZ_VERSION='"for-test"' -I$(srcdir) \
	  $(shell cat $(srcdir)/COPYRIGHT_YEARS)

min:
	$(CC) $(TEST_SRC)/min.c $(TEST_SRC)/min-2.c -o $@ -g

two-typedef:
	$(CC) $(TEST_SRC)/two-typedef.c $(TEST_SRC)/two-typedef-2.c \
	  -I $(TEST_SRC) -o $@ -g

start:
	$(CC) $(TEST_SRC)/start.c -o $@ -g -nostdlib

start-gold:
	$(CC) $(TEST_SRC)/start.c -fuse-ld=gold -o $@ -g -nostdlib || touch $@

implptr-64bit-d2o4a8r8t0:
	$(CC) $(TEST_SRC)/implptr-64bit-d2o4a8r8t0.S $(TEST_SRC)/main.c \
	  -o $@ -g

hello-gold-gdb-index:
	$(CC) $(TEST_SRC)/hello.c -g -fuse-ld=gold -Wl,--gdb-index -o $@ \
	    || touch $@

varval:
	$(CC) $(TEST_SRC)/varval.c $(TEST_SRC)/varval.S -g -o $@

POINTER_SIZE:=$(shell $(CC) $(TEST_SRC)/pointer-size.c -o pointer-size; \
	./pointer-size; \
	rm -f ./pointer-size)

TEMP_ASM_FILES=$(addsuffix -dw.S, $(TEST_EXECS_DWARF_ASM))
.INTERMEDIATE: $(TEMP_ASM_FILES)

$(TEMP_ASM_FILES): %-dw.S: $(TEST_SRC)/../lib/%.exp
	export POINTER_SIZE=$(POINTER_SIZE); \
	  export DEJAGNU=$(DEJAGNU); \
	  runtest --tool=dwz -srcdir $(srcdir)/testsuite/ lib/$*.exp

$(TEST_EXECS_DWARF_ASM): %: %-dw.S
	$(CC) $(TEST_SRC)/main.c $< -o $@

odr-struct:
	$(CXX) $(TEST_SRC)/odr.cc $(TEST_SRC)/odr-2.cc -I$(TEST_SRC) -o $@ -g \
	  -DKIND=struct

odr-class:
	$(CXX) $(TEST_SRC)/odr.cc $(TEST_SRC)/odr-2.cc -I$(TEST_SRC) -o $@ -g \
	  -DKIND=class

odr-union:
	$(CXX) $(TEST_SRC)/odr.cc $(TEST_SRC)/odr-2.cc -I$(TEST_SRC) -o $@ -g \
	  -DKIND=union

odr-struct-ns:
	$(CXX) $(TEST_SRC)/odr.cc $(TEST_SRC)/odr-2.cc -I$(TEST_SRC) -o $@ -g \
	  -DKIND=struct -DNAMESPACE=1

odr-class-ns:
	$(CXX) $(TEST_SRC)/odr.cc $(TEST_SRC)/odr-2.cc -I$(TEST_SRC) -o $@ -g \
	  -DKIND=class -DNAMESPACE=1

odr-union-ns:
	$(CXX) $(TEST_SRC)/odr.cc $(TEST_SRC)/odr-2.cc -I$(TEST_SRC) -o $@ -g \
	  -DKIND=union -DNAMESPACE=1

odr-loc:
	$(CXX) $(TEST_SRC)/odr-loc.cc $(TEST_SRC)/odr-loc-2.cc -I$(TEST_SRC) \
	  -o $@ -g


def-decl:
	$(CXX) $(TEST_SRC)/decl.c $(TEST_SRC)/def.c $(TEST_SRC)/def2.c -I$(TEST_SRC) \
	  -o $@ -g

# On some systems we need to set and export DEJAGNU to suppress
# WARNING: Couldn't find the global config file.
DEJAGNU ?= /dev/null

check: dwz $(TEST_EXECS)
	mkdir -p testsuite-bin
	cd testsuite-bin; ln -sf $(PWD)/dwz .
	export DEJAGNU=$(DEJAGNU); \
	export PATH=$(PWD)/testsuite-bin:$$PATH; export LC_ALL=C; \
	runtest --tool=dwz -srcdir $(srcdir)/testsuite $(RUNTESTFLAGS)
	rm -Rf testsuite-bin $(TEST_EXECS) $(DWZ_TEST_SOURCES)

## dwz 0.13+20210201

=== Makefile ===
--- 
+++ 
@@ -44,10 +44,10 @@
 
 dw2-skip-prologue:
 	$(CC) $(TEST_SRC)/dw2-skip-prologue.S $(TEST_SRC)/dw2-skip-prologue.c \
-	  -DINLINED -DPTRBITS=64 -o $@
+	  -DINLINED -DPTRBITS=64 -o $@ || touch $@
 
 py-section-script:
-	$(CC) $(TEST_SRC)/py-section-script.s -o $@ -g
+	$(CC) $(TEST_SRC)/py-section-script.s -o $@ -g || touch $@
 
 DWZ_TEST_SOURCES := $(patsubst %.o,%-for-test.c,$(OBJECTS))
 
@@ -74,14 +74,14 @@
 
 implptr-64bit-d2o4a8r8t0:
 	$(CC) $(TEST_SRC)/implptr-64bit-d2o4a8r8t0.S $(TEST_SRC)/main.c \
-	  -o $@ -g
+	  -o $@ -g || touch $@
 
 hello-gold-gdb-index:
 	$(CC) $(TEST_SRC)/hello.c -g -fuse-ld=gold -Wl,--gdb-index -o $@ \
 	    || touch $@
 
 varval:
-	$(CC) $(TEST_SRC)/varval.c $(TEST_SRC)/varval.S -g -o $@
+	$(CC) $(TEST_SRC)/varval.c $(TEST_SRC)/varval.S -g -o $@ || touch $@
 
 POINTER_SIZE:=$(shell $(CC) $(TEST_SRC)/pointer-size.c -o pointer-size; \
 	./pointer-size; \

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Priority: optional
 Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 11),
   libelf-dev,
   dejagnu <!nocheck>,
   elfutils <!nocheck>,
   gdb <!nocheck>,
-Standards-Version: 4.4.1
+Standards-Version: 4.5.1
 Homepage: https://www.sourceware.org/dwz/
 
 Package: dwz

## dwz 0.14

=== debian/changelog ===
dwz (0.14-1build2) jammy; urgency=medium

  * No-change rebuild for ppc64el baseline bump.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Wed, 23 Mar 2022 14:51:21 +0100

dwz (0.14-1build1) impish; urgency=medium

  * No-change rebuild to build packages with zstd compression.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Oct 2021 12:11:04 +0200

dwz (0.14-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Mon, 08 Mar 2021 15:35:45 +0100

dwz (0.13+20210219-1) experimental; urgency=medium

  * Snapshot build, taken from the trunk 20210219.

 -- Matthias Klose <doko@debian.org>  Fri, 19 Feb 2021 14:34:09 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper (>= 13),
   libelf-dev,
   dejagnu <!nocheck>,
   elfutils <!nocheck>,

## dwz 0.14+20220924

=== Makefile ===
--- 
+++ 
@@ -3,36 +3,59 @@
 else
 srcdir=$(shell pwd)
 endif
+
 CFLAGS = -O2 -g
 DWZ_VERSION := $(shell cat $(srcdir)/VERSION)
-override CFLAGS += -Wall -W -D_FILE_OFFSET_BITS=64 \
-	-DDWZ_VERSION='"$(DWZ_VERSION)"' $(shell cat $(srcdir)/COPYRIGHT_YEARS)
+CFLAGS_VERSION = -DDWZ_VERSION='"$(DWZ_VERSION)"'
+CFLAGS_COPYRIGHT = $(shell cat $(srcdir)/COPYRIGHT_YEARS)
+CFLAGS_COMMON = -Wall -W -D_FILE_OFFSET_BITS=64 -DXXH_INLINE_ALL=1
+override CFLAGS += $(CFLAGS_COMMON) $(CFLAGS_VERSION) $(CFLAGS_COPYRIGHT)
+
 prefix = /usr
 exec_prefix = $(prefix)
 bindir = $(exec_prefix)/bin
 datarootdir = $(prefix)/share
 mandir = $(datarootdir)/man
-OBJECTS = dwz.o hashtab.o sha1.o dwarfnames.o
+OBJECTS = args.o dwz.o hashtab.o pool.o sha1.o dwarfnames.o
+LIBS=-lelf
 dwz: $(OBJECTS)
-	$(CC) $(LDFLAGS) -o $@ $^ -lelf
+	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
+args.o: native.o
+args.o: CFLAGS_FOR_SOURCE = \
+	-DNATIVE_ENDIAN_VAL=$(NATIVE_ENDIAN_VAL) \
+	-DNATIVE_POINTER_SIZE=$(NATIVE_POINTER_SIZE)
+NATIVE_ENDIAN=$(shell readelf -h native.o \
+	| grep Data \
+	| sed 's/.*, //;s/ endian//')
+NATIVE_ENDIAN_LITTLE=$(findstring $(NATIVE_ENDIAN),$(findstring little,$(NATIVE_ENDIAN)))
+NATIVE_ENDIAN_BIG=$(findstring $(NATIVE_ENDIAN),$(findstring big,$(NATIVE_ENDIAN)))
+NATIVE_ENDIAN_VAL=$(if $(NATIVE_ENDIAN_LITTLE),ELFDATA2LSB,$(if $(NATIVE_ENDIAN_BIG),ELFDATA2MSB,ELFDATANONE))
+NATIVE_POINTER_SIZE=$(shell readelf -wi native.o \
+	| grep "Pointer Size:" \
+	| sed 's/.*: *//')
+%.o: %.c
+	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $< $(CFLAGS_FOR_SOURCE)
 install: dwz
 	install -D dwz $(DESTDIR)$(bindir)/dwz
 	install -D -m 644 $(srcdir)/dwz.1 $(DESTDIR)$(mandir)/man1/dwz.1
 clean:
-	rm -f $(OBJECTS) *~ core* dwz $(TEST_EXECS) $(DWZ_TEST_SOURCES) \
-	  dwz.log dwz.sum
+	rm -f $(OBJECTS) *~ core* dwz $(TEST_EXECS) $(DWZ_TEST_OBJECTS) \
+	  dwz.log dwz.sum native.o
 	rm -Rf testsuite-bin tmp.*
+native.o: native.c
+	$(CC) -o $@ $< -c -g
 
 PWD:=$(shell pwd -P)
 
 TEST_SRC = $(srcdir)/testsuite/dwz.tests
-TEST_EXECS_DWARF_ASM = no-multifile-prop invalid-dw-at-stmt-list-encoding
+TEST_EXECS_DWARF_ASM = no-multifile-prop invalid-dw-at-stmt-list-encoding \
+		       unavailable-dwarf-piece
 TEST_EXECS_x86_64 = py-section-script dw2-skip-prologue \
 	implptr-64bit-d2o4a8r8t0 varval
 TEST_EXECS = hello dwz-for-test min two-typedef start hello-gold-gdb-index \
 	start-gold hello-gnu-pubnames $(TEST_EXECS_DWARF_ASM) \
 	$(TEST_EXECS_$(UNAME)) odr-struct odr-class odr-union odr-struct-ns \
-	odr-class-ns odr-union-ns odr-loc def-decl
+	odr-class-ns odr-union-ns odr-loc def-decl cycle
 
 UNAME:=$(shell uname -p)
 
@@ -49,15 +72,21 @@
 py-section-script:
 	$(CC) $(TEST_SRC)/py-section-script.s -o $@ -g || touch $@
 
-DWZ_TEST_SOURCES := $(patsubst %.o,%-for-test.c,$(OBJECTS))
-
-%-for-test.c: %.c
-	sed 's/__GNUC__/NOT_DEFINED/' $< > $@
-
-dwz-for-test: $(DWZ_TEST_SOURCES)
-	$(CC) $(DWZ_TEST_SOURCES) -O2 -g -lelf -o $@ -Wall -W -DDEVEL \
-	  -D_FILE_OFFSET_BITS=64 -DDWZ_VERSION='"for-test"' -I$(srcdir) \
-	  $(shell cat $(srcdir)/COPYRIGHT_YEARS)
+DWZ_TEST_OBJECTS := $(patsubst %.o,%-for-test.o,$(OBJECTS))
+dwz-for-test: $(DWZ_TEST_OBJECTS)
+	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
+	rm -f $(DWZ_TEST_OBJECTS)
+args-for-test.o: CFLAGS_FOR_SOURCE = \
+	-DNATIVE_ENDIAN_VAL=$(NATIVE_ENDIAN_VAL) \
+	-DNATIVE_POINTER_SIZE=$(NATIVE_POINTER_SIZE)
+$(DWZ_TEST_OBJECTS): %-for-test.o : %.c
+	$(CC) $< -o $@ -c \
+	  -DUSE_GNUC=0 -DDEVEL \
+	  -O2 -g \
+	  $(CFLAGS_COMMON) \
+	  -DDWZ_VERSION='"for-test"' \
+	  $(CFLAGS_COPYRIGHT) \
+	  $(CFLAGS_FOR_SOURCE)
 
 min:
 	$(CC) $(TEST_SRC)/min.c $(TEST_SRC)/min-2.c -o $@ -g
@@ -95,8 +124,12 @@
 	  export DEJAGNU=$(DEJAGNU); \
 	  runtest --tool=dwz -srcdir $(srcdir)/testsuite/ lib/$*.exp
 
-$(TEST_EXECS_DWARF_ASM): %: %-dw.S
+$(filter-out no-multifile-prop unavailable-dwarf-piece, $(TEST_EXECS_DWARF_ASM)): %: %-dw.S
 	$(CC) $(TEST_SRC)/main.c $< -o $@
+
+# Fails to compile on riscv64: Error: non-constant .uleb128 is not supported.
+no-multifile-prop unavailable-dwarf-piece: %: %-dw.S
+	$(CC) $(TEST_SRC)/main.c $< -o $@ || true
 
 odr-struct:
 	$(CXX) $(TEST_SRC)/odr.cc $(TEST_SRC)/odr-2.cc -I$(TEST_SRC) -o $@ -g \
@@ -128,17 +161,28 @@
 
 
 def-decl:
-	$(CXX) $(TEST_SRC)/decl.c $(TEST_SRC)/def.c $(TEST_SRC)/def2.c -I$(TEST_SRC) \
-	  -o $@ -g
+	$(CXX) $(TEST_SRC)/decl.cc $(TEST_SRC)/def.cc $(TEST_SRC)/def2.cc \
+	  -I$(TEST_SRC) -o $@ -g
+
+cycle:
+	$(CC) $(TEST_SRC)/cycle.c -o $@ -g
 
 # On some systems we need to set and export DEJAGNU to suppress
 # WARNING: Couldn't find the global config file.
 DEJAGNU ?= /dev/null
 
-check: dwz $(TEST_EXECS)
+VALGRIND_OPTIONS = -q --error-exitcode=99
+
+check check-valgrind: dwz $(TEST_EXECS)
 	mkdir -p testsuite-bin
-	cd testsuite-bin; ln -sf $(PWD)/dwz .
+	cd testsuite-bin; \
+	  if [ "$@" = "check" ]; then \
+	    ln -sf $(PWD)/dwz .; \
+	  else \
+	    echo "valgrind $(VALGRIND_OPTIONS) $(PWD)/dwz \"\$$@\"" > dwz; \
+	    chmod +x dwz; \
+	  fi
 	export DEJAGNU=$(DEJAGNU); \
 	export PATH=$(PWD)/testsuite-bin:$$PATH; export LC_ALL=C; \
 	runtest --tool=dwz -srcdir $(srcdir)/testsuite $(RUNTESTFLAGS)
-	rm -Rf testsuite-bin $(TEST_EXECS) $(DWZ_TEST_SOURCES)
+	rm -Rf testsuite-bin $(TEST_EXECS) $(DWZ_TEST_OBJECTS)

## dwz 0.15

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,15 @@
 DWZ_VERSION := $(shell cat $(srcdir)/VERSION)
 CFLAGS_VERSION = -DDWZ_VERSION='"$(DWZ_VERSION)"'
 CFLAGS_COPYRIGHT = $(shell cat $(srcdir)/COPYRIGHT_YEARS)
-CFLAGS_COMMON = -Wall -W -D_FILE_OFFSET_BITS=64 -DXXH_INLINE_ALL=1
+CFLAGS_COMMON = -Wall -W -D_FILE_OFFSET_BITS=64
+XXH_PROG = "\#define XXH_INLINE_ALL 1\n\#include <xxhash.h>\n"
+XXH_INLINE_ALL_WORKS = $(shell printf $(XXH_PROG) \
+		| $(CC) -xc -c - -o /dev/null 2>/dev/null \
+		&& echo -n 1)
+ifeq "$(XXH_INLINE_ALL_WORKS)" "1"
+  CFLAGS_COMMON += -DXXH_INLINE_ALL=1
+endif
+
 override CFLAGS += $(CFLAGS_COMMON) $(CFLAGS_VERSION) $(CFLAGS_COPYRIGHT)
 
 prefix = /usr
@@ -18,6 +26,9 @@
 mandir = $(datarootdir)/man
 OBJECTS = args.o dwz.o hashtab.o pool.o sha1.o dwarfnames.o
 LIBS=-lelf
+ifneq "$(XXH_INLINE_ALL_WORKS)" "1"
+LIBS += -lxxhash
+endif
 dwz: $(OBJECTS)
 	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
 args.o: native.o
@@ -40,8 +51,10 @@
 	install -D -m 644 $(srcdir)/dwz.1 $(DESTDIR)$(mandir)/man1/dwz.1
 clean:
 	rm -f $(OBJECTS) *~ core* dwz $(TEST_EXECS) $(DWZ_TEST_OBJECTS) \
-	  dwz.log dwz.sum native.o
+	  dwz.log dwz.sum native.c native.o
 	rm -Rf testsuite-bin tmp.*
+native.c:
+	echo "int main (void) { return 0; }" > $@
 native.o: native.c
 	$(CC) -o $@ $< -c -g

=== debian/changelog ===
dwz (0.15-1build6) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:53:17 +1100

dwz (0.15-1build5) noble; urgency=medium

  * Revert bootstrapping hacks

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Mar 2024 04:51:14 +0000

dwz (0.15-1build4) noble; urgency=medium

  * Drop build-dependency on gdb temporarily

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Mar 2024 03:13:08 +0000

dwz (0.15-1build3) noble; urgency=medium

  * Temporary versioned build-dep on debhelper for bootstrap

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Mar 2024 03:03:41 +0000

dwz (0.15-1build2) noble; urgency=medium

  * Temporary Build-Conflicts: against dwz to try to unstick.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Mar 2024 02:56:36 +0000

dwz (0.15-1build1) noble; urgency=medium

  * No-change rebuild against libelf1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Mar 2024 00:57:53 +0000

dwz (0.15-1) unstable; urgency=medium

  * New upstream release.

 -- Matthias Klose <doko@debian.org>  Mon, 26 Dec 2022 11:45:14 +0100

dwz (0.14+20220924-2) unstable; urgency=medium

  * Upload to unstable.

 -- Matthias Klose <doko@debian.org>  Thu, 29 Sep 2022 17:22:09 +0200

dwz (0.14+20220924-1) experimental; urgency=medium

  * New upstream snapshot, taken from the trunk.
  * Build-depend on libxxhash-dev.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Sat, 24 Sep 2022 07:25:32 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,16 @@
 Source: dwz
 Section: devel
 Priority: optional
-Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 13),
   libelf-dev,
+  libxxhash-dev,
   dejagnu <!nocheck>,
   elfutils <!nocheck>,
   gdb <!nocheck>,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Homepage: https://www.sourceware.org/dwz/
 
 Package: dwz

=== debian/watch ===
version=3
http://sourceware.org/git/?p=dwz.git;a=summary .*h=refs/tags/dwz-(\d.*)

## dwz 0.16

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 DWZ_VERSION := $(shell cat $(srcdir)/VERSION)
 CFLAGS_VERSION = -DDWZ_VERSION='"$(DWZ_VERSION)"'
 CFLAGS_COPYRIGHT = $(shell cat $(srcdir)/COPYRIGHT_YEARS)
-CFLAGS_COMMON = -Wall -W -D_FILE_OFFSET_BITS=64
+CFLAGS_COMMON = -Wall -W -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
 XXH_PROG = "\#define XXH_INLINE_ALL 1\n\#include <xxhash.h>\n"
 XXH_INLINE_ALL_WORKS = $(shell printf $(XXH_PROG) \
 		| $(CC) -xc -c - -o /dev/null 2>/dev/null \

=== debian/changelog ===
dwz (0.16-2) unstable; urgency=medium

  * Upload to unstable.

 -- Matthias Klose <doko@debian.org>  Mon, 01 Sep 2025 13:31:02 +0200

dwz (0.16-1) experimental; urgency=medium

  * New upstream release.
  * Bump debhelper and standards versions.

 -- Matthias Klose <doko@debian.org>  Thu, 12 Jun 2025 11:11:41 +0200

=== debian/control ===
Source: dwz
Section: devel
Priority: optional
Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
Uploaders: Matthias Klose <doko@debian.org>
Build-Depends: debhelper-compat (= 13),
  libelf-dev,
  libxxhash-dev,
  dejagnu <!nocheck>,
  elfutils <!nocheck>,
  gdb <!nocheck>,
Standards-Version: 4.7.2
Homepage: https://www.sourceware.org/dwz/

Package: dwz
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: DWARF compression tool
 DWARF optimizer and duplication removal utility.

=== debian/rules ===
--- 
+++ 
@@ -4,8 +4,8 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-DEB_BUILD_OPTIONS := $(DEB_BUILD_OPTIONS) nostrip noopt
-export DEB_BUILD_OPTIONS
+#DEB_BUILD_OPTIONS := $(DEB_BUILD_OPTIONS) nostrip noopt
+#export DEB_BUILD_OPTIONS
 
 CFLAGS  := $(shell dpkg-buildflags --get CPPFLAGS; dpkg-buildflags --get CFLAGS)
 LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
